ForwardingListenableFuture
Date: 2016-05-24

com.google.common.util.concurrent

## Class ForwardingListenableFuture<V>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.util.concurrent.ForwardingFuture<V>
    - - com.google.common.util.concurrent.ForwardingListenableFuture<V>

- Type Parameters:
    `V` - The result type returned by this Future's `get` method
  All Implemented Interfaces:
    ListenableFuture<V>, java.util.concurrent.Future<V>
  Direct Known Subclasses:
    ForwardingCheckedFuture, ForwardingListenableFuture.SimpleForwardingListenableFuture

      public abstract class ForwardingListenableFuture<V>
      extends ForwardingFuture<V>
      implements ListenableFuture<V>

  A `ListenableFuture` which forwards all its method calls to another future. Subclasses should override one or more methods to modify the behavior of the backing future as desired per the decorator pattern.

  Most subclasses can just use `ForwardingListenableFuture.SimpleForwardingListenableFuture`.

  Since:
    4.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ForwardingListenableFuture.SimpleForwardingListenableFuture<V>` A simplified version of `ForwardingListenableFuture` where subclasses can pass in an already constructed `ListenableFuture` as the delegate.

    - ### Nested classes/interfaces inherited from class com.google.common.util.concurrent.ForwardingFuture

      `ForwardingFuture.SimpleForwardingFuture<V>`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingListenableFuture()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addListener(java.lang.Runnable listener, java.util.concurrent.Executor exec)` Registers a listener to be run on the given executor.
    `protected abstract ListenableFuture<V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.

    - ### Methods inherited from class com.google.common.util.concurrent.ForwardingFuture

      `cancel, get, get, isCancelled, isDone`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.concurrent.Future

      `cancel, get, get, isCancelled, isDone`

- - ### Constructor Detail

    - #### ForwardingListenableFuture

          protected ForwardingListenableFuture()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract ListenableFuture<V> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingFuture<V>`

    - #### addListener

          public void addListener(java.lang.Runnable listener,
                         java.util.concurrent.Executor exec)

      Description copied from interface: `ListenableFuture`
      Registers a listener to be run on the given executor. The listener will run when the `Future`'s computation is complete or, if the computation is already complete, immediately.

      There is no guaranteed ordering of execution of listeners, but any listener added through this method is guaranteed to be called once the computation is complete.

      Exceptions thrown by a listener will be propagated up to the executor. Any exception thrown during `Executor.execute` (e.g., a `RejectedExecutionException` or an exception thrown by direct execution) will be caught and logged.

      Note: For fast, lightweight listeners that would be safe to execute in any thread, consider `MoreExecutors.directExecutor()`. Otherwise, avoid it. Heavyweight `directExecutor` listeners can cause problems, and these problems can be difficult to reproduce because they depend on timing. For example:

      - The listener may be executed by the caller of `addListener`. That caller may be a UI thread or other latency-sensitive thread. This can harm UI responsiveness.
      - The listener may be executed by the thread that completes this `Future`. That thread may be an internal system thread such as an RPC network thread. Blocking that thread may stall progress of the whole system. It may even cause a deadlock.
      - The listener may delay other listeners, even listeners that are not themselves `directExecutor` listeners.

      This is the most general listener interface. For common operations performed using listeners, see `Futures`. For a simplified but general listener interface, see `addCallback()`.

      Memory consistency effects: Actions in a thread prior to adding a listener happen-before its execution begins, perhaps in another thread.

      Specified by:
        `addListener` in interface `ListenableFuture<V>`
      Parameters:
        `listener` - the listener to run when the computation is complete
        `exec` - the executor to run the listener in